using System;
using System.Collections;
using Microsoft.Ink;
using Microsoft.StylusInput;
using Microsoft.StylusInput.PluginData;

namespace WindowsApplication1
{
	/// <summary>
	/// Simple ink collection object
	/// </summary>
	public class InkBuilder : Microsoft.StylusInput.IStylusAsyncPlugin
	{
        private Ink myInk = new Ink();
        private ArrayList packets = new ArrayList();

		public InkBuilder()
		{
			// 
			// TODO: Add constructor logic here
			//
		}

        public Ink Ink
        {
            get { return myInk; }
            set { myInk = value; }
        }

        #region IStylusAsyncPlugin Members

        public void TabletRemoved(Microsoft.StylusInput.RealTimeStylus sender, Microsoft.StylusInput.PluginData.TabletRemovedData data)
        {
            // TODO:  Add InkBuilder.TabletRemoved implementation
        }

        public void CustomStylusDataAdded(Microsoft.StylusInput.RealTimeStylus sender, Microsoft.StylusInput.PluginData.CustomStylusData data)
        {
            // TODO:  Add InkBuilder.CustomStylusDataAdded implementation
        }

        public void RealTimeStylusDisabled(Microsoft.StylusInput.RealTimeStylus sender, Microsoft.StylusInput.PluginData.RealTimeStylusDisabledData data)
        {
            // TODO:  Add InkBuilder.RealTimeStylusDisabled implementation
        }

        public Microsoft.StylusInput.DataInterestMask DataInterest
        {
            get
            {
                return (DataInterestMask)((int)DataInterestMask.StylusDown
                    | (int)DataInterestMask.StylusUp | (int)DataInterestMask.Packets);
            }
        }

        public void StylusOutOfRange(Microsoft.StylusInput.RealTimeStylus sender, Microsoft.StylusInput.PluginData.StylusOutOfRangeData data)
        {
            // TODO:  Add InkBuilder.StylusOutOfRange implementation
        }

        public void StylusButtonUp(Microsoft.StylusInput.RealTimeStylus sender, Microsoft.StylusInput.PluginData.StylusButtonUpData data)
        {
            // TODO:  Add InkBuilder.StylusButtonUp implementation
        }

        public void StylusInRange(Microsoft.StylusInput.RealTimeStylus sender, Microsoft.StylusInput.PluginData.StylusInRangeData data)
        {
            // TODO:  Add InkBuilder.StylusInRange implementation
        }

        public void RealTimeStylusEnabled(Microsoft.StylusInput.RealTimeStylus sender, Microsoft.StylusInput.PluginData.RealTimeStylusEnabledData data)
        {
            // TODO:  Add InkBuilder.RealTimeStylusEnabled implementation
        }

        public void SystemGesture(Microsoft.StylusInput.RealTimeStylus sender, Microsoft.StylusInput.PluginData.SystemGestureData data)
        {
            // TODO:  Add InkBuilder.SystemGesture implementation
        }

        public void StylusDown(Microsoft.StylusInput.RealTimeStylus sender, Microsoft.StylusInput.PluginData.StylusDownData data)
        {
            packets.AddRange(data.GetData());
        }

        public void TabletAdded(Microsoft.StylusInput.RealTimeStylus sender, Microsoft.StylusInput.PluginData.TabletAddedData data)
        {
            // TODO:  Add InkBuilder.TabletAdded implementation
        }

        public void Error(Microsoft.StylusInput.RealTimeStylus sender, Microsoft.StylusInput.PluginData.ErrorData data)
        {
            // TODO:  Add InkBuilder.Error implementation
        }

        public void InAirPackets(Microsoft.StylusInput.RealTimeStylus sender, Microsoft.StylusInput.PluginData.InAirPacketsData data)
        {
            // TODO:  Add InkBuilder.InAirPackets implementation
        }

        public void Packets(Microsoft.StylusInput.RealTimeStylus sender, Microsoft.StylusInput.PluginData.PacketsData data)
        {
            packets.AddRange(data.GetData());
        }

        public void StylusUp(Microsoft.StylusInput.RealTimeStylus sender, Microsoft.StylusInput.PluginData.StylusUpData data)
        {
            if(0 < packets.Count)
            {
                TabletPropertyDescriptionCollection tpdc = sender.GetTabletPropertyDescriptionCollection(data.Stylus.TabletContextId);
                myInk.CreateStroke((int [])packets.ToArray(typeof(int)), tpdc);
                packets.Clear();
            }
        }

        public void StylusButtonDown(Microsoft.StylusInput.RealTimeStylus sender, Microsoft.StylusInput.PluginData.StylusButtonDownData data)
        {
            // TODO:  Add InkBuilder.StylusButtonDown implementation
        }

        #endregion
    }
}
